//mobファイルをバイナリとして組み込んでロード
package monochromebit
{
	import jp.live2d.model.Live2DModel;
	import flash.utils.*
	import flash.display.*;
	import flash.geom.*;//マトリックス用
	/**
	 * @author knov
	 * 多量のＭＯＢ埋め込み活用
	 * ビットマップ出力
	 * ビットマップ化はLive2DModelを引数にしたほうが色々とおいしいので
	 * 
	 */
	public class L2dUtilCls{
		public var l2dMod:Live2DModel;

		/**コンストラクタ**/
		public function L2dUtilCls():void{}
		
		//スプライトをビットマップデータ化して返す
		//BitmapData型で返す必要がある
		public function getBitmapModel(l2dMod:Live2DModel,reSize:Number):BitmapData{
			
			var tmpRect:Rectangle = l2dMod.getCanvasBounds();
			// 透明なBitmapDataを用意。背景を塗りつぶすため
			var _modBmd:BitmapData = new BitmapData(tmpRect.width*reSize ,tmpRect.height*reSize,true ,0x00000000);//関数内で作成する必要がある
			
			//スプライト取得
			var tmpSpt:Sprite = l2dMod.getSprite();
			
			var mtxElem:Matrix = new Matrix();// 表示位置はMatrixで指定する
			mtxElem.scale(reSize ,reSize);//拡大縮小
			mtxElem.translate(0 ,0);   // ( , )の位置に描画する設定にする
			_modBmd.draw(tmpSpt,mtxElem,null,null,null,true); //spriteをラスタライズ
			return _modBmd;
		}//getBitmapModelEND

		//モデルを生成して返す
		public function getModel(element:int):Live2DModel{
			//MOD_LISTからモデルロード
			l2dMod = loadBinMod(element);//○番めのmob読み込み
			return l2dMod;
		}//getModelEND

		//バイナリからモデルロード
		private function loadBinMod(element:int):Live2DModel{
			MOB_LIST[element];
			var byteArray:ByteArray;
			byteArray = new MOB_LIST[element] as ByteArray;
			return Live2DModel.loadFromByteArray(byteArray);
		}//loadBinModEND

include "../moblist.as"//mob登録リスト

	}//classEND
}/**packageEND**/
